#include <stdio.h>
#include <errno.h>
#include <strings.h>
#include <assert.h>

#include <dirent.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <netinet/tcp.h>
#include <signal.h>
#include <assert.h>

#include <db-ndbm.h>
#include <krb5.h>
#include <com_err.h>
#include <krb5/kdb.h>
#include <kadm5/admin.h>
 
/* the next 2 includes are coming from the 
 * kerberos src directory (not install)
 */
#include <lib/kdb/kdb_db2.h>  
#include <lib/kadm5/server_internal.h>                                                    

#include "util.h"

#include <openssl/evp.h>
#include <openssl/tls1.h>
#include <openssl/ssl3.h>
#include <openssl/x509.h>
#include <openssl/x509_vfy.h>
#include <openssl/bio.h>
#include <openssl/err.h>


typedef struct tgs_context_struct {
  int                 ws_sock;

  char                *client_id;
  char                *client_realm;

  char                *ws_id;
  char                *ws_realm;

  char                *service_id;
  char                *service_realm;

  krb5_context        krb_context;
  krb5_keytab         tgs_keytab;
  krb5_principal      tgs_server;
  krb5_auth_context   ws_auth_context;
  krb5_ticket         *ws_ticket;
} tgs_context;

#define s2n(c,s)        ((s=(((unsigned int)(c[0]))<< 8)| \
                            (((unsigned int)(c[1]))    )),c+=2)
