#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>

#define BUFF_SIZE 1024
#define TGSLOG_EMERG     0       /* system is unusable */
#define TGSLOG_ALERT     1       /* action must be taken immediately */
#define TGSLOG_CRIT      2       /* critical conditions */
#define TGSLOG_ERR       3       /* error conditions */
#define TGSLOG_WARNING   4       /* warning conditions */
#define TGSLOG_NOTICE    5       /* normal but significant condition */
#define TGSLOG_INFO      6       /* informational */
#define TGSLOG_DEBUG     7       /* debug-level messages */

FILE *f;

void *get_memory(size_t, size_t);
void free_memory(void *memory);
int open_log();
void close_log();
int log(int, char *, ...);
char *get_time(time_t);
size_t recvblock(int sd, unsigned char *buf, size_t total);
size_t sendblock(int sd, unsigned char *buf, size_t total);
void print_buffer(unsigned char *buffer, size_t len, unsigned char *comment);
